#include "cntl2.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc, char**argv){
	struct in_addr 			ip;
	ControlPacketStatReply	st;
	char*					target="This is a test set stuff\0";
	unsigned int			BuffID;
	
	struct stat				s;
	char*					fullbuff;
	int						fp;
	
	if (argc == 1){
		printf("Hogwash Buffer Set v1.0 by Anonpoet\n\n");
		printf("Sends an encrypted Buffer\n\n");
		printf("Usage:\n");
		printf("hsetbuff <IP Adress> [<buffer id>|ALERT|RULES|LOG] <filename>\n");
		return 0;
	}
	
	inet_aton(argv[1],&ip);
	
	BuffID=STOCK_BUFFER_NEW_RULES;
	/*if (argc>2){
		if (strcmp(argv[2],"ALERT")==0){
			BuffID=STOCK_BUFFER_ALERT;
		}else if (strcmp(argv[2],"RULES")==0){
			BuffID=STOCK_BUFFER_RULES;
		}else if (strcmp(argv[2],"LOG")==0){
			BuffID=STOCK_BUFFER_LOG;
		}
	}else{
		printf("Invalid usage:\n");
		exit(0);
	}*/
	
	hm_init("control.conf");
	
	if (stat(argv[2], &s)==-1){
		printf("error getting stat(%s)\n",argv[3]);
	}
	printf("File is %i bytes long\n",s.st_size);
	fullbuff=(char*)calloc(s.st_size, 1);
	fp=open(argv[2],O_RDONLY);
	read(fp, fullbuff, s.st_size);
	
	BuffID=STOCK_BUFFER_NEW_RULES;
	if (!hb_get_stat(ip, BuffID, &st)){
		printf("Error getting stat!\n");
		return 0;
	}
	if (hb_set_buff(ip, BuffID, fullbuff, s.st_size)){
		printf("Success\n");
	}else{
		printf("Failed\n");
	}
	hm_close();
}
